<script lang="ts">
    import { createEventDispatcher } from 'svelte'

    import Upload from './Upload.svelte'
    import Selection from './Selection.svelte'

    import { description } from '../common/description'
    import { HnetWorker } from '../common/associate'
    import { associations } from '../common/associations'
    import { debug } from '../common/debug'

    import { options } from './options'
    import Progress from '../../ui/Progress.svelte'
    import Spinner from '../../ui/Spinner.svelte'
    import SaveLoadSelection from './SaveLoadSelection.svelte'

    const dispatch = createEventDispatcher()

    let uploading = false
    let error: string | undefined

    $: steps = []
    $: progress = -1

    const associateWorker = new HnetWorker()

    associateWorker.onStep((msg) => {
        steps = [...steps, msg.step]
    })

    associateWorker.onProgress((msg) => {
        progress = msg.progress
    })

    function explore() {
        if ($description.fromExportFile) {
            dispatch('next')
            return
        }

        uploading = true

        associateWorker.associateData($description, $options)
            .then((assoc) => {
                $associations = assoc
                dispatch('next')
                reset()
            })
            .catch((e) => {
                console.error('associateData catch', e)
                error = e.message ?? String(e)
                reset()
            })
    }

    function reset() {
        associateWorker.abort()
        uploading = false
        progress = 0
        steps = []
    }
</script>

{#if error}
    <div class="border-2 border-red-800 text-red-800 rounded bg-red-200 p-2 m-4">{error}</div>
{/if}

{#if !uploading}
    <Upload bind:error={error}/>
{:else}
    <ul>
        {#each steps as step, i}
            <li>
                <span class="inline-block p-4">{step}</span>
                {#if i === steps.length - 1}<Spinner/>{/if}
            </li>
        {/each}
    </ul>
    {#if progress !== -1}
        <Progress {progress}/>
    {/if}
{/if}

{#if $description}
    <div class="flex flex-col lg:flex-row justify-between lg:items-end m-4">
        <div>
            <div class="text-2xl py-2">
                {$description.filename} ( {$description.shape[0]} rows, {$description.shape[1]} features )
            </div>
            {#if !$description.fromExportFile}
                <SaveLoadSelection/>
            {/if}
        </div>

        {#if !uploading}
            <button class="py-4 px-8 bg-geel text-2xl" on:click={explore}>
                Explore associations &rsaquo;
            </button>
        {:else}
            <button class="py-4 px-8 bg-geel text-2xl" on:click={reset}>
                Abort
            </button>
        {/if}

    </div>

<!--    TODO disabled if uploading-->
    <Selection/>

{/if}
